function init()
	tool_name = "fimninetytwostingergs"
    RegisterTool(tool_name, "FIM-92 Stinger", "MOD/vox/Stinger.vox", 4)
	SetBool("game.tool." .. tool_name ..".enabled", true)
	SetFloat("game.tool." .. tool_name .. ".ammo", 101)
	heat_vision = {0, 0, {0, 0, 0}, 0, 0, 0, {0, 0, 0}, 0}
	missiles = {}
	camera_mode = 0
	tool_locked = true
	cam_tr = {Transform(), 0}
	aim_progress = 0
	grabing = false
	lock = {0, -1, Vec(0, 0, 0), false, 0} --trying to lock timer, target shape, target local vec, locked, trigger timer
	explosion_power = GetInt("savegame.mod.explosion_power")*0.25+0.5
	ui_par = {0, 0}
	sight = GetInt("savegame.mod.sight")
	ready_fire = true
	ammo = 5
	ani = {0, 0} --step, frame
	
	Sight_Input = GetString("savegame.mod.sight_input")
	if Sight_Input == "" then Sight_Input = "T" end
	no_reload = GetBool("savegame.mod.no_reload")
	unlimited_ammo = GetBool("savegame.mod.unlimited_ammo")
	targeting_mode = GetInt("savegame.mod.targeting_mode")
	
	lock_loop = LoadLoop("MOD/snd/Lock.ogg")
	engine_loop = LoadLoop("MOD/snd/Engine.ogg")
	engine_start_sound = LoadSound("MOD/snd/EngineStart.ogg")
	insert_coolant_sound = LoadSound("MOD/snd/InsertCoolant.ogg")
	pick_up_sound = LoadSound("MOD/snd/PickUp.ogg")
	optic_unfold_sound = LoadSound("MOD/snd/OpticUnfold.ogg")
end

function shoot(launch_tr, target, target_pos)
	instance = Spawn("MOD/Rocket.xml", launch_tr)
	SetTag(instance[1], "unbreakable")
	SetTag(instance[1], "nocull")
	SetBodyDynamic(instance[1], false)
	local sh = GetBodyShapes(instance[1])
	for i = 2, 3 do
		SetShapeLocalTransform(sh[i], TransformToParentTransform(GetShapeLocalTransform(sh[i]), Transform(Vec(0, -99, 0))))
	end
	table.insert(missiles, {instance[1], launch_tr, target, target_pos, 0, Vec(0, 0, 0), 0, 0})
	lock = {0, -1, Vec(0, 0, 0), false, 0}
	PlaySound(engine_start_sound, GetPlayerCameraTransform().pos)
	if not no_reload then ready_fire = false end
	if not unlimited_ammo then ammo = ammo - 1 end
	if ammo == 0 then ready_fire = false end
	--1missile body, 2missile transform, 3target id, 4local target pos, 5speed, 6last target location, 7time since spawn, 8target lost timer
end

function tick(dt)
	if GetString("game.player.tool") == tool_name and GetPlayerVehicle() == 0 then
		local grabing = GetPlayerGrabShape()
		if grabing > 0 then grabing = true else grabing = false end
		if not InputDown("lmb") then tool_locked = GetBool("game.player.canusetool") end
		local sps = GetBodyShapes(GetToolBody())
		SetShapeLocalTransform(sps[2], Transform(Vec(0.175, -0.25, -0.5), QuatEuler(-90, 0, 0))) --lower part
		SetShapeLocalTransform(sps[5], Transform(Vec(0, 0, 999), QuatEuler(-90, 0, 0))) --coolant
		SetShapeLocalTransform(sps[6], Transform(Vec(0.175, -0.3, -0.755), QuatEuler(-90, 0, 0))) --coolant base
		SetShapeLocalTransform(sps[7], Transform(Vec(0.2-0.035, -0.25, -0.78-0.02), QuatEuler(-90, 0, 0))) --coolant ouline
		SetShapeLocalTransform(sps[8], Transform(Vec(0.2-0.035, -0.25, -0.78+0.02), QuatEuler(-90, 0, 0)))
		SetShapeLocalTransform(sps[9], Transform(Vec(0.2+0.035, -0.25, -0.78-0.02), QuatEuler(-90, 0, 0)))
		SetShapeLocalTransform(sps[10], Transform(Vec(0.2+0.035, -0.25, -0.78+0.02), QuatEuler(-90, 0, 0)))
		SetShapeLocalTransform(sps[11], Transform(Vec(0.16, 0.09, -0.8), QuatEuler(-90, 0, 75))) --optic
		if InputDown("rmb") and not grabing and ani[1] == 0 then
            aim_progress = math.min(aim_progress + dt * 3, 1)
        else
            aim_progress = math.max(aim_progress - dt * 3, 0)
        end
		local tool_transform = Transform()
		tool_transform = Transform(VecLerp(Vec(0.1, 0, 0.1), Vec(0, -0.155, 0.55), math.min(aim_progress/0.8, 1)), QuatSlerp(QuatEuler(-25, 15, 0), QuatEuler(0, 0, 0), math.min(aim_progress/0.8, 1)))
		if aim_progress == 1 then 
			SetShapeLocalTransform(sps[11], Transform(Vec(0, 0, 999)))
			SetBool("game.input.locktool", true) 
			if InputValue("mousewheel") ~= 0 then 
				ui_par[1] = 1 
				explosion_power = math.max(math.min(explosion_power + InputValue("mousewheel") * 0.25, 4), 0.5)
				SetFloat("savegame.mod.explosion_power", math.floor((explosion_power-0.5)/0.25+0.5))
			end
		end
		ui_par[1] = math.max(ui_par[1]-dt, 0)
		ui_par[2] = math.max(ui_par[2]-dt, 0)
		if aim_progress == 1 and InputPressed("lmb") and not ready_fire then ui_par[2] = 1 end
		if targeting_mode == 0 then
			if aim_progress == 1 and ready_fire then
				local hit, dist, normal, shape = QueryRaycast(GetPlayerCameraTransform().pos, TransformToParentVec(GetPlayerCameraTransform(), Vec(0, 0, -1)), 900)
				if hit and not lock[4] then
					lock[1] = math.min(lock[1]+dt*1.2, 1)
					if lock[1] == 1 then
						lock[2] = shape
						local pos = VecAdd(GetPlayerCameraTransform().pos, VecScale(TransformToParentVec(GetPlayerCameraTransform(), Vec(0, 0, -1)), dist))
						local loc_pos = TransformToLocalPoint(GetShapeWorldTransform(shape), pos)
						lock[3] = loc_pos
						if InputPressed("lmb") then
							lock[4] = true
						end
					end
				elseif not lock[4] then
					lock[1] = math.max(lock[1]-dt*1.2, 0)
				end
				if lock[4] then
					if VecNormalize(TransformToLocalPoint(GetPlayerCameraTransform(), TransformToParentPoint(GetShapeWorldTransform(lock[2]), lock[3])))[3] > -0.8 then lock[4], lock[1] = false, 0.5 end
					if InputDown("lmb") then
						lock[5] = math.min(lock[5]+dt, 0.5)
					else
						lock[5] = math.max(lock[5]-dt, 0)
					end
					if lock[5] == 0.5 and tool_locked then
						shoot(TransformToParentTransform(GetPlayerCameraTransform(), Transform(Vec(0.235, 0.025, 0))), lock[2], lock[3])
					end
				end
				PlayLoop(lock_loop, GetPlayerCameraTransform().pos, lock[1])
			else
				lock = {0, -1, Vec(0, 0, 0), false, 0}
			end
		elseif targeting_mode == 1 then
			if InputPressed("lmb") and aim_progress == 1 and tool_locked and ready_fire then
				local hit, dist, normal, shape = QueryRaycast(GetPlayerCameraTransform().pos, TransformToParentVec(GetPlayerCameraTransform(), Vec(0, 0, -1)), 900)
				if hit then
					local pos = VecAdd(GetPlayerCameraTransform().pos, VecScale(TransformToParentVec(GetPlayerCameraTransform(), Vec(0, 0, -1)), dist))
					local loc_pos = TransformToLocalPoint(GetShapeWorldTransform(shape), pos)
					shoot(TransformToParentTransform(GetPlayerCameraTransform(), Transform(Vec(0.235, 0.025, 0))), shape, loc_pos)
				end
			end
		end
		if not(ready_fire) and aim_progress ~= 1 and ani[1] == 0 and ammo > 0 then
			ani = {1, 0}
		end
		if ani[1] == 1 or ani[1] == 1.5 then
			ani[2] = math.min(ani[2]+dt*0.8, 1)
			if ani[1] == 1 and ani[2] > 0.6 then PlaySound(pick_up_sound) ani[1] = 1.5 end
			if ani[2] == 1 then
				ani = {2, 0}
			else
			    tool_transform = Transform(VecLerp(tool_transform.pos, Vec(0.02, -0.7, 0.06), ani[2]), QuatSlerp(tool_transform.rot, QuatEuler(-20, 40, 0), ani[2]))
			end
		end
		if ani[1] == 2 then
			ani[2] = math.min(ani[2]+dt*0.8, 1)
			SetShapeLocalTransform(sps[6], Transform(Vec(0, 0, 999), QuatEuler(-90, 0, 0)))
			SetShapeLocalTransform(sps[11], Transform(Vec(0.16, 0.09, -0.8), QuatEuler(-90, 0, 180)))
			if ani[2] == 1 then
				ani = {3, 0}
				PlaySound(insert_coolant_sound)
			else
			    tool_transform = Transform(VecLerp(Vec(0.02, -0.7, 0.06), Vec(0.1, -0.25, 0.06), ani[2]), QuatSlerp(QuatEuler(-20, 40, 0), QuatEuler(20, 5, -20), ani[2]))
			end
		end
		if ani[1] == 3 then
			ani[2] = math.min(ani[2]+dt*1.5, 1)
			if math.min(ani[2]/0.8, 1) ~= 1 then
				SetShapeLocalTransform(sps[5], Transform(Vec(0.175, -1+0.7*math.min(ani[2]/0.8, 1), -0.755), QuatEuler(-90, 0, 0)))
				SetShapeLocalTransform(sps[6], Transform(Vec(0, 0, 999), QuatEuler(-90, 0, 0)))
			end
			SetShapeLocalTransform(sps[11], Transform(Vec(0.16, 0.09, -0.8), QuatEuler(-90, 0, 180)))
			if ani[2] == 1 then
				ani = {4, 0}
				PlaySound(optic_unfold_sound)
			else
			    tool_transform = Transform(VecLerp(Vec(0.1, -0.25, 0.06), Vec(0, -0.3, 0.06), math.min(ani[2]/0.8, 1)), QuatSlerp(QuatEuler(20, 5, -20), QuatEuler(25, 5, -25), math.min(ani[2]/0.8, 1)))
			end
		end
		if ani[1] == 4 then
			ani[2] = math.min(ani[2]+dt, 1)
			SetShapeLocalTransform(sps[11], Transform(Vec(0.16, 0.09, -0.8), QuatEuler(-90, 0, 180-105*math.min(ani[2]/0.8, 1))))
			if ani[2] == 1 then
				ani = {5, 0}
				ready_fire = true
			else
				tool_transform = Transform(VecLerp(Vec(0, -0.3, 0.06), Vec(0.1, -0.55, 0.06), math.min(ani[2]/0.8, 1)), QuatSlerp(QuatEuler(25, 5, -25), QuatEuler(25, 5, 5), math.min(ani[2]/0.8, 1)))
			end
		end
		if ani[1] == 5 then
			ani[2] = math.min(ani[2]+dt*1.5, 1)
			if ani[2] == 1 then
				ani = {0, 0}
				ready_fire = true
			else
				tool_transform = Transform(VecLerp(Vec(0.1, -0.55, 0.06), tool_transform.pos, ani[2]), QuatSlerp(QuatEuler(25, 5, 5), tool_transform.rot, ani[2]))
			end
		end
		SetToolTransform(tool_transform)
		if InputPressed("R") then camera_mode = math.fmod(camera_mode+1, 3) end
		if InputPressed(Sight_Input) then sight = math.fmod(sight+1, 2) SetInt("savegame.mod.sight", sight) end
		if sight == 1 and heat_vision[1] == 0 and aim_progress == 1 and (camera_mode == 0 or #missiles == 0) and cam_tr[2] == 0 then
			heat_vision[3][1], heat_vision[3][2], heat_vision[3][3] = GetPostProcessingProperty("colorbalance")
			heat_vision[7][1], heat_vision[7][2], heat_vision[7][3] = GetEnvironmentProperty("constant")
			heat_vision[2], heat_vision[4], heat_vision[5], heat_vision[6], heat_vision[8] = GetPostProcessingProperty("saturation"), GetPostProcessingProperty("brightness"), GetPostProcessingProperty("gamma"), GetPostProcessingProperty("bloom"), GetEnvironmentProperty("ambient") 
			SetPostProcessingProperty("saturation", 0)
			SetPostProcessingProperty("colorbalance", 0.9, 0.9, 0.9)
			SetPostProcessingProperty("brightness", 1.5)
			SetPostProcessingProperty("gamma", 0.2)
			SetPostProcessingProperty("bloom", 0)
			SetEnvironmentProperty("constant", 0.1, 0.1, 0.1)
			SetEnvironmentProperty("ambient", 0)
			heat_vision[1] = 1
		end
		if heat_vision[1] == 1 then
			local bodies = FindBodies("", true)
			for i = 1, #bodies do
				if IsBodyDynamic(bodies[i]) then 
					if IsBodyActive(bodies[i]) then
						DrawBodyHighlight(bodies[i], math.max(VecLength(GetBodyVelocity(bodies[i]))*1000, 1))
					end
				else
					local e = VecDot(Vec(0, 1, 0), TransformToParentVec(GetBodyTransform(bodies[i]), Vec(1, 0, 0)))
					if not(e == 1 or e == 0 or e == -1) then
						local a, b = GetBodyBounds(bodies[i])
						local size = VecLength(VecSub(b, a))
						if bodies[i] ~= GetToolBody() and size > 3 and (HasTag(bodies[i], "unbreakable") or not IsBodyBroken(bodies[i]) or HasTag(bodies[i], "irtargetgs")) then
							DrawBodyHighlight(bodies[i], 500)
							if not HasTag(bodies[i], "irtargetgs") then SetTag(bodies[i], "irtargetgs") end
						end
					end
				end
			end
		end
	end
	if heat_vision[1] == 1 and (sight == 0 or aim_progress < 1 or not(GetString("game.player.tool") == tool_name and GetPlayerVehicle() == 0) or not(camera_mode == 0 or #missiles == 0) or cam_tr[2] > 0) then
		SetPostProcessingProperty("saturation", heat_vision[2])
		SetPostProcessingProperty("colorbalance", heat_vision[3][1], heat_vision[3][2], heat_vision[3][3])
		SetPostProcessingProperty("brightness", heat_vision[4])
		SetPostProcessingProperty("gamma", heat_vision[5])
		SetPostProcessingProperty("bloom", heat_vision[6])
		SetEnvironmentProperty("constant", heat_vision[7][1], heat_vision[7][2], heat_vision[7][3])
		SetEnvironmentProperty("ambient", heat_vision[8])
		heat_vision[1] = 0
	end
	local delete_missile = {}
	for i = 1, #missiles do
		local m = missiles[i]
		local trg_pos = TransformToParentPoint(GetShapeWorldTransform(m[3]), m[4])
		m[7] = m[7] + dt
		local t
		if m[7] > 0.1 and GetShapeLocalTransform(GetBodyShapes(m[1])[3]).pos[3] > 1 then
			local sh = GetBodyShapes(m[1])
			for u = 2, 3 do
				SetShapeLocalTransform(sh[u], TransformToParentTransform(GetShapeLocalTransform(sh[u]), Transform(Vec(0, 99, 0))))
			end
		end
		if m[7] < 0.275 then
			t = 5
			m[2] = TransformToParentTransform(m[2], Transform(Vec(0, 0, -m[5]*dt)))
			m[2].pos = VecAdd(m[2].pos, Vec(0, -m[7]*0.5, 0))
		else
			pl_m_dist = VecLength(VecSub(m[2].pos, GetCameraTransform().pos))
			PlayLoop(engine_loop, GetCameraTransform().pos, math.min(500/pl_m_dist^2+0.05, 1))
			local trg_vel = VecScale(VecSub(trg_pos, m[6]), 1/dt)
			local trg_dis = VecLength(VecSub(trg_pos, m[2].pos))
			t = trg_dis/m[5]
			local imp_pos = VecAdd(trg_pos, VecScale(trg_vel, t))
			local dir_vec = TransformToLocalPoint(m[2], imp_pos)
			local dir_angle = {math.deg(math.atan(dir_vec[1]/math.abs(dir_vec[3]))), math.deg(math.atan(dir_vec[2]/math.abs(dir_vec[3])))}
			if dir_vec[3] > 0 then
				if dir_angle[1] < 0 then dir_angle[1] = -180-dir_angle[1] else dir_angle[1] = 180-dir_angle[1] end
				if dir_angle[2] < 0 then dir_angle[2] = -180-dir_angle[2] else dir_angle[2] = 180-dir_angle[2] end
			end
			local max_turn = math.min(math.atan(1/(m[7]/50))*4, 20)*14*dt
			dir_angle = {math.min(math.max(dir_angle[1], -max_turn), max_turn), math.min(math.max(dir_angle[2], -max_turn), max_turn)}
			m[2] = TransformToParentTransform(m[2], Transform(Vec(0, 0, -m[5]*dt), QuatEuler(dir_angle[2], -dir_angle[1], 0)))
			ParticleRadius(0.2, 0.7)
			ParticleAlpha(1, 0)
			SpawnParticle(TransformToParentPoint(m[2], Vec(0, 0, 1.3)), TransformToParentVec(m[2], Vec(0, 0, -m[7]*0.8)), 1.5)
		end
		if TransformToLocalPoint(m[2], trg_pos)[3] > 0 then
			m[8] = m[8] + dt
		else
			m[8] = 0
		end
		m[5] = math.max(math.atan(m[7]-0.02)*90, -(m[7]*10)^2+30)
		SetBodyTransform(m[1], TransformToParentTransform(m[2], Transform(Vec(-0.025, -0.025, 0))))
		m[6] = trg_pos
		if i == 1 then 
			if camera_mode == 1 then
				SetCameraTransform(TransformToParentTransform(GetBodyTransform(m[1]), Transform(Vec(-1, 1, 2+math.max(1-t, 0)*6)))) 
			elseif camera_mode == 2 then
				local tr1 = Transform(trg_pos, QuatLookAt(trg_pos, m[2].pos))
				local tr1 = TransformToParentTransform(tr1, Transform(Vec(10+math.max(5-t, 0)*2, 7, 20-math.max(5-t, 0)*6)))
				SetCameraTransform(Transform(tr1.pos, QuatLookAt(tr1.pos, VecLerp(trg_pos, m[2].pos, 0.75))))
			end
		end
		if m[7] > 20 or m[8] > 1.5 then
			Explosion(GetBodyTransform(m[1]).pos, explosion_power)
			if camera_mode ~= 0 then cam_tr = {GetCameraTransform(), 1} end
			table.insert(delete_missile, 1, i)
		else
			QueryRejectBody(m[1])
			local hit, dist, normal, shape = QueryRaycast(m[2].pos, TransformToParentVec(m[2], Vec(0, 0, -1)), m[5]*dt+0.1)
			if hit then
				local hit_pos = VecAdd(m[2].pos, VecScale(TransformToParentVec(m[2], Vec(0, 0, -1)), dist))
				Explosion(hit_pos, explosion_power)
				if camera_mode ~= 0 then cam_tr = {GetCameraTransform(), 1} end
				table.insert(delete_missile, 1, i)
			end
		end
	end
	if cam_tr[2] > 0 then
		SetCameraTransform(cam_tr[1])
	end
	cam_tr[2] = math.max(cam_tr[2]-dt, 0)
	for i = 1, #delete_missile do
		Delete(missiles[delete_missile[i]][1])
		table.remove(missiles, delete_missile[i])
	end
end

function draw()
    if GetString("game.player.tool") == tool_name and GetPlayerVehicle() == 0 then
		if aim_progress == 1 and (camera_mode == 0 or #missiles == 0) and cam_tr[2] == 0 then
			SetBool("hud.aimdot", false)
			SetCameraFov(40)
			if sight == 0 then
				UiPush()
					local pos_end = VecAdd(TransformToParentPoint(GetShapeWorldTransform(GetBodyShapes(GetToolBody())[1]), Vec(-0.15, -5, 0.205)), VecScale(GetPlayerVelocity(), GetTimeStep()))
					x, y, dis = UiWorldToPixel(pos_end)
					UiTranslate(x, y)
					UiAlign("center middle")
					UiImage("MOD/img/Front.png")
					UiImage("MOD/img/Outline.png")
					UiScale(60)
					UiImage("MOD/img/Dark.png")
				UiPop()
				UiPush()
					UiTranslate(960+(x-960)*2, 540+(y-540)*2)
					UiAlign("center middle")
					UiImage("MOD/img/Back.png")
					UiImage("MOD/img/Outline.png")
					UiScale(60)
					UiImage("MOD/img/Dark.png")
				UiPop()
			else
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle")
					UiColorFilter(1, 1, 1, 0.3)
					UiImage("MOD/img/Target_Circle.png")
					if lock[4] then
						local pos = TransformToParentPoint(GetShapeWorldTransform(lock[2]), lock[3])
						x, y, dis = UiWorldToPixel(pos)
						UiTranslate(x, y)
					end
					UiImage("MOD/img/Cross.png")
				UiPop()
			end
			for i = 1, math.floor(lock[1]*3) do
				UiPush()
					UiTranslate(1700, 950-(i-1)*30)
					UiAlign("center middle")
					if lock[4] then UiColor(1, 0.3, 0.2) end
					UiImage("MOD/img/Shake.png")
				UiPop()
			end
			UiPush()
				UiTranslate(1700, 1000)
				UiAlign("center middle")
				UiFont("bold.ttf", 32)
				UiTextOutline(0,0,0,1,0.1)
				local t = ""
				if camera_mode == 1 then t = "Follow missile" elseif camera_mode == 2 then t = "Follow Target" end
				UiText(t)
			UiPop()
		end
		UiPush()
			UiTranslate(UiCenter(), UiMiddle()+75)
			UiAlign("center middle")
			UiColor(1, 1, 1)
			UiFont("bold.ttf", 32)
			UiTextOutline(0,0,0,ui_par[1])
			UiColor(1, 1, 1, ui_par[1])
			UiText("Explosion Power: " .. explosion_power)
		UiPop()
		UiPush()
			UiTranslate(UiCenter(), UiMiddle()+25)
			UiAlign("center middle")
			UiColor(1, 1, 1)
			UiFont("bold.ttf", 32)
			UiTextOutline(0,0,0,ui_par[2])
			UiColor(1, 1, 1, ui_par[2])
			UiText("Launch Tube is Empty")
		UiPop()
		UiPush()
	        UiTranslate(UiCenter(), UiHeight()-60)
		    UiAlign("center middle")
		    UiColor(1, 1, 1)
		    UiFont("bold.ttf", 32)
		    UiTextOutline(0,0,0,1,0.1)
		    if not unlimited_ammo then UiText(ammo) end
		UiPop()
	end
end